
!WAApplication methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/7/2009 18:01'!
handleDefaultRequest: aRequestContext
	| session |
	session := self sessionClass forContext: aRequestContext.
	self register: session.
	^ session handleRequest: aRequestContext! !

!WARequestContext methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/10/2009 09:13'!
isActionPhase
	"Answers true if the receiver is in the action phase."

	^ (self request includesKey: '_k') and:[
	self session isActionPhaseForContext: self]! !

!WAActionPhaseContinuation methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/10/2009 09:16'!
isActionPhase

	^ true! !

!WASession class methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/7/2009 17:57'!
forContext: aRequestContext

	^ self new initializeForContext: aRequestContext ! !

!WASession methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/7/2009 17:59'!
initializeForContext: aRequestContext 
	"Initializes the receiver for aRequestContext.
	Applicability: sometimes the request (or the first request) helps 
	to define how the session should be set. If that's the case, subclasses
	can override this method to set its own settings."
	
	"no-op by default"
	! !

!WASession methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/10/2009 09:18'!
isActionPhaseForContext: aRequestContext
	"Answers true if the receiver found a continuation
	in an action phase for the request of aRequestContext."
	| action |
	action := continuations at: (aRequestContext request at: '_k').
	^ action notNil and:[
	action isActionPhase]
	! !

!WARenderLoopContinuation methodsFor: '*seaside-patch' stamp: 'sebastian.sastre 3/10/2009 09:16'!
isActionPhase

	^ false! !
